Index: /trunk/gsdl3/src/java/org/greenstone/gsdl3/service/GS2MGPPRetrieve.java
===================================================================
--- /trunk/gsdl3/src/java/org/greenstone/gsdl3/service/GS2MGPPRetrieve.java	(revision 8958)
+++ /trunk/gsdl3/src/java/org/greenstone/gsdl3/service/GS2MGPPRetrieve.java	(revision 8959)
@@ -1,5 +1,5 @@
 /*
  *    GS2MGPPRetrieve.java
- *    Copyright (C) 2002 New Zealand Digital Library, http://www.nzdl.org
+ *    Copyright (C) 2005 New Zealand Digital Library, http://www.nzdl.org
  *
  *    This program is free software; you can redistribute it and/or modify
@@ -19,27 +19,20 @@
 package org.greenstone.gsdl3.service;
 
-
 // Greenstone classes
 import org.greenstone.mgpp.*;
-import org.greenstone.gsdl3.util.*;
+import org.greenstone.gsdl3.util.GSFile;
+import org.greenstone.gsdl3.util.GSXML;
 
 // XML classes
-import org.w3c.dom.Element; 
+import org.w3c.dom.Element;
+import org.w3c.dom.Text;
 
 // General Java classes
 import java.io.File;
 
-
-/**
- * A ServiceRack class for retrieval in greenstone 2 MGPP collections
- *
- * @author <a href="mailto:kjdon@cs.waikato.ac.nz">Katherine Don</a>
- * @version $Revision$
- * @see ServiceRack
- */
-public class GS2MGPPRetrieve 
-    extends GS2Retrieve {
-
-    // Parameters used
+public class GS2MGPPRetrieve
+    extends AbstractGS2DocumentRetrieve
+{
+     // Parameters used
     private static final String LEVEL_PARAM = "level";
 
@@ -50,15 +43,9 @@
     
     private String default_level = null;
-
-
-    /** constructor */
-    public GS2MGPPRetrieve()
-    {
+    private String mgpp_textdir = null;
+	
+    public GS2MGPPRetrieve() {
 	this.mgpp_src = new MGPPWrapper();
-	// only the classifier service has strings at present
-	this.dictionary_name = "ClassifierBrowse";
-
     }
-
 
     /** configure this service */
@@ -78,79 +65,46 @@
 	}
 	// System.out.println("Default level: " + default_level_);
+	
+	// The location of the MGPP text files
+	mgpp_textdir = GSFile.collectionBaseDir(this.site_home, this.cluster_name) +
+	    File.separatorChar + GSFile.collectionTextPath(this.cluster_name);
 
 	// Do generic configuration
 	return super.configure(info, extra_info);
+ 
+    }
+    
+    /** returns the content of a node
+     * should return a nodeContent element:
+     * <nodeContent>text content or other elements</nodeContent>
+     */
+    protected Element getNodeContent(String doc_id) {
+	String lang = "en"; //  ********** 
+	long doc_num = this.gdbm_src.OID2Docnum(doc_id);
+	if (doc_num == -1) {
+	    System.err.println("OID "+doc_id +" couldn't be converted to mgpp num");
+	    return null;
+	}
+	Element content_node = this.doc.createElement(GSXML.NODE_CONTENT_ELEM);
+	
+	String doc_content = "";
+	try {
+	    doc_content = this.mgpp_src.getDocument(this.mgpp_textdir, 
+						    this.default_level,
+						    doc_num);
+	    if (doc_content != null) {
+		doc_content = resolveTextMacros(doc_content, doc_id, lang);
+	    } 
+	} catch (Exception e) {
+	    System.out.println("exception happended with mgpp_src.getDocument()" + e);
+	    doc_content = "this is the content for section hash id "+ doc_id+", mgpp doc num "+doc_num+"\n";
+
+	}
+	Text t = this.doc.createTextNode(doc_content);
+	content_node.appendChild(t);
+	return content_node;
+
     }
 
-    
-    /** Retrieve the content of a document */
-    protected Element processDocumentContentRetrieve(Element request)
-    {
-	// Create a new (empty) result message
-	Element result = this.doc.createElement(GSXML.RESPONSE_ELEM);
-	result.setAttribute(GSXML.FROM_ATT,DOCUMENT_CONTENT_RETRIEVE_SERVICE );
-	result.setAttribute(GSXML.TYPE_ATT, GSXML.REQUEST_TYPE_PROCESS);
 
-	// Get the parameters of the request 
-	Element param_list = (Element) GSXML.getChildByTagName(request, GSXML.PARAM_ELEM+GSXML.LIST_MODIFIER);
-	Element extlink_param = GSXML.getNamedElement(param_list, GSXML.PARAM_ELEM, GSXML.NAME_ATT, EXTLINK_PARAM);
-	boolean extlink = false;
-	if (extlink_param != null && GSXML.getValue(extlink_param).equals("1")) {
-	    extlink = true;
-	}
-
-	// Get the request doc_list
-	Element query_doc_list = (Element) GSXML.getChildByTagName(request, GSXML.DOC_NODE_ELEM+GSXML.LIST_MODIFIER);
-	if (query_doc_list == null) {
-	    System.err.println("Error: DocumentContentRetrieve request specified no doc nodes.\n");
-	    return result;
-	}
-	String lang = request.getAttribute(GSXML.LANG_ATT);
-	Element doc_list = this.doc.createElement(GSXML.DOC_NODE_ELEM+GSXML.LIST_MODIFIER);
-	result.appendChild(doc_list);
-
-	// The location of the MGPP text files
-	String textdir = GSFile.collectionBaseDir(this.site_home, this.cluster_name) +
-	    File.separatorChar + GSFile.collectionTextPath(this.cluster_name);
-
-	// Get the documents
-	String[] doc_ids = GSXML.getAttributeValuesFromList(query_doc_list, 
-						     GSXML.NODE_ID_ATT);
-	for (int i = 0; i < doc_ids.length; i++) {
-	    String doc_id = doc_ids[i];
-	    Element doc = this.doc.createElement(GSXML.DOC_NODE_ELEM);
-	    doc.setAttribute(GSXML.NODE_ID_ATT, doc_id);
-	    doc_list.appendChild(doc);
-	    
-	    if (extlink) {
-		doc_id = this.gdbm_src.extlink2OID(doc_id);
-		if (doc_id==null) {
-		    continue;
-		}
-		doc.setAttribute(GSXML.NODE_ID_ATT, doc_id);
-	    }
-	    else if (OID.needsTranslating(doc_id)) {
-		doc_id = this.gdbm_src.translateOID(doc_id);
-		if (doc_id==null) {
-		    continue;
-		}
-		doc.setAttribute(GSXML.NODE_ID_ATT, doc_id);
-	    }
-	    
-	    long doc_num = this.gdbm_src.OID2Docnum(doc_id);
-	    if (doc_num == -1) {
-		continue;
-	    }
-	    String doc_content = this.mgpp_src.getDocument(textdir, this.default_level, doc_num);
-	    doc_content = resolveTextMacros(doc_content, doc_id, lang);
-	    
-	    // For now, stick it in a text node - eventually should be parsed as xml??
-	    GSXML.addDocText(this.doc, doc, doc_content);
-	    
-
-	}
-	
-	return result;
-    }
 }
-
Index: /trunk/gsdl3/src/java/org/greenstone/gsdl3/service/GS2MGRetrieve.java
===================================================================
--- /trunk/gsdl3/src/java/org/greenstone/gsdl3/service/GS2MGRetrieve.java	(revision 8958)
+++ /trunk/gsdl3/src/java/org/greenstone/gsdl3/service/GS2MGRetrieve.java	(revision 8959)
@@ -1,5 +1,5 @@
 /*
  *    GS2MGRetrieve.java
- *    Copyright (C) 2002 New Zealand Digital Library, http://www.nzdl.org
+ *    Copyright (C) 2005 New Zealand Digital Library, http://www.nzdl.org
  *
  *    This program is free software; you can redistribute it and/or modify
@@ -19,44 +19,30 @@
 package org.greenstone.gsdl3.service;
 
-
 // Greenstone classes
 import org.greenstone.mg.*;
-import org.greenstone.gsdl3.util.*;
+import org.greenstone.gsdl3.util.GSFile;
+import org.greenstone.gsdl3.util.GSXML;
 
 // XML classes
 import org.w3c.dom.Element;
+import org.w3c.dom.Text;
 
 // General Java classes
 import java.io.File;
 
-
-/**
- *
- * @author <a href="mailto:kjdon@cs.waikato.ac.nz">Katherine Don</a>
- * 
- */
-
 public class GS2MGRetrieve
-    extends GS2Retrieve {
-
-    // Parameters used
-    private static final String INDEX_PARAM = "index";
-
+    extends AbstractGS2DocumentRetrieve
+{
     // Elements used in the config file that are specific to this class
     private static final String DEFAULT_INDEX_ELEM = "defaultIndex";
 
     private MGWrapper mg_src = null;
-
+    private String mg_basedir = null;
+    private String mg_textdir = null;
     private String default_index = null;
-
-
-    /** constructor */
-    public GS2MGRetrieve()
-    {
+	
+    public GS2MGRetrieve() {
 	this.mg_src = new MGWrapper();
-	// only the classifier service has strings at present
-	this.dictionary_name = "ClassifierBrowse";
     }
-
 
     /** configure this service */
@@ -79,93 +65,47 @@
 	// System.out.println("Default index: " + this.default_index);
 
+	// The location of the MG index and text files
+	mg_basedir = GSFile.collectionBaseDir(this.site_home, this.cluster_name) + File.separatorChar;  // Needed by MG
+	mg_textdir = GSFile.collectionTextPath(this.cluster_name);
+	// index is only needed to start up MG, not used so just use the default index
+	String indexpath = GSFile.collectionIndexPath(this.cluster_name, this.default_index);
+	this.mg_src.setIndex(indexpath);
+
 	// Do generic configuration
 	return super.configure(info, extra_info);
     }
+    
+    /** returns the content of a node
+     * should return a nodeContent element:
+     * <nodeContent>text content or other elements</nodeContent>
+     */
+    protected Element getNodeContent(String doc_id) {
+	String lang = "en"; //  ********** 
+	long doc_num = this.gdbm_src.OID2Docnum(doc_id);
+	if (doc_num == -1) {
+	    System.err.println("OID "+doc_id +" couldn't be converted to mg num");
+	    return null;
+	}
+	Element content_node = this.doc.createElement(GSXML.NODE_CONTENT_ELEM);
+	
+	String doc_content = this.mg_src.getDocument(this.mg_basedir,
+						     this.mg_textdir, doc_num);
+	
+	if (doc_content!=null) {
+	    // remove any ctrl-c or ctrl-b 
+	    doc_content = doc_content.replaceAll("\u0002|\u0003", "");
+	    // replace _httpimg_ with the correct address
+	    doc_content = resolveTextMacros(doc_content, doc_id, lang);
+	    //GSXML.addDocText(this.doc, doc, doc_content);
+	} else {
+	    System.err.println("the doc content was null, not getting that section\n");
+	    doc_content = "couldn't retrieve content for this section\n";
+	}
+	Text t = this.doc.createTextNode(doc_content);
+	content_node.appendChild(t);
+	return content_node;
+
+    }
 
 
-    /** Retrieve the content of a document */
-    protected Element processDocumentContentRetrieve(Element request)
-    {
-	// Create a new (empty) result message
-	Element result = this.doc.createElement(GSXML.RESPONSE_ELEM);
-	result.setAttribute(GSXML.FROM_ATT, DOCUMENT_CONTENT_RETRIEVE_SERVICE);
-	result.setAttribute(GSXML.TYPE_ATT, GSXML.REQUEST_TYPE_PROCESS);
-
-	// Get the parameters of the request - no parameters at this stage
-  	Element param_list = (Element) GSXML.getChildByTagName(request, GSXML.PARAM_ELEM+GSXML.LIST_MODIFIER);
-	Element extlink_param = GSXML.getNamedElement(param_list, GSXML.PARAM_ELEM, GSXML.NAME_ATT, EXTLINK_PARAM);
-	boolean extlink = false;
-	if (extlink_param != null && GSXML.getValue(extlink_param).equals("1")) {
-	    extlink = true;
-	}
-	// Get the request content 
-	Element query_doc_list = (Element) GSXML.getChildByTagName(request, GSXML.DOC_NODE_ELEM+GSXML.LIST_MODIFIER);
-	if (query_doc_list == null) {
-	    System.err.println("Error: DocumentContentRetrieve request specified no doc nodes.\n");
-	    return result;
-	}
-	
-	String lang = request.getAttribute(GSXML.LANG_ATT);
-	Element doc_list = this.doc.createElement(GSXML.DOC_NODE_ELEM+GSXML.LIST_MODIFIER);
-	result.appendChild(doc_list);
-	
-	// The location of the MG index and text files
-	String basedir = GSFile.collectionBaseDir(this.site_home, this.cluster_name) + File.separatorChar;  // Needed by MG
-	String textdir = GSFile.collectionTextPath(this.cluster_name);
-	// index is only needed to start up MG, not used so just use the default index
-	String indexpath = GSFile.collectionIndexPath(this.cluster_name, this.default_index);
-	this.mg_src.setIndex(indexpath);
-	
-	// Get the documents
-	String[] doc_ids = GSXML.getAttributeValuesFromList(query_doc_list, 
-							     GSXML.NODE_ID_ATT);
-	for (int i = 0; i < doc_ids.length; i++) {
-	    String doc_id = doc_ids[i];
-	    // Create the document node
-	    Element doc = this.doc.createElement(GSXML.DOC_NODE_ELEM);
-	    doc.setAttribute(GSXML.NODE_ID_ATT, doc_id);
-	    doc_list.appendChild(doc);
-	    
-	    if (extlink) {
-		if (OID.needsTranslating(doc_id)) {
-		    
-		    // just ignore the extension cos it has no meaning here
-		    // or should it be added back on for the next step???
-		    doc_id = this.gdbm_src.extlink2OID(doc_id.substring(0,doc_id.length()-3));
-		} else {
-		    doc_id = this.gdbm_src.extlink2OID(doc_id);
-		}
-		if (doc_id == null) {
-		    System.err.println("extlink "+doc_id +" couldn't be converted to proper id");
-		    continue;
-		}
-		doc.setAttribute(GSXML.NODE_ID_ATT, doc_id); // reset the att cos it may have changed
-		    
-	    }
-	    else if (OID.needsTranslating(doc_id)) {
-		doc_id = this.gdbm_src.translateOID(doc_id);
-		doc.setAttribute(GSXML.NODE_ID_ATT, doc_id); // reset the att cos it may have changed
-	    }
-	    
-	    long doc_num = this.gdbm_src.OID2Docnum(doc_id);
-	    if (doc_num == -1) {
-		System.err.println("OID "+doc_id +" couldn't be converted to mg num");
-		continue;
-	    }
-	    String doc_content = this.mg_src.getDocument(basedir, textdir, doc_num);
-	    
-	    if (doc_content!=null) {
-		// remove any ctrl-c or ctrl-b (I hope these are the right codes)
-		doc_content = doc_content.replaceAll("\u0002|\u0003", "");
-		// replace _httpimg_ with the correct address
-		doc_content = resolveTextMacros(doc_content, doc_id, lang);
-		GSXML.addDocText(this.doc, doc, doc_content);
-	    } else {
-		System.err.println("the doc content was null, not getting that section\n");
-		GSXML.addDocText(this.doc, doc, "couldn't retrieve content for this section\n");
-	    }
-	}
-
-	return result;
-    }
 }
Index: /trunk/gsdl3/src/java/org/greenstone/gsdl3/service/GS2Retrieve.java
===================================================================
--- /trunk/gsdl3/src/java/org/greenstone/gsdl3/service/GS2Retrieve.java	(revision 8958)
+++ /trunk/gsdl3/src/java/org/greenstone/gsdl3/service/GS2Retrieve.java	(revision 8959)
@@ -73,5 +73,5 @@
     protected static final String INFO_SIB_POS = "siblingPosition";
 
-    protected static final String EXTLINK_PARAM = "ext";
+    protected static final String EXTID_PARAM = "ext";
     
     protected static final int DOCUMENT=1;
@@ -462,5 +462,5 @@
 		node.setAttribute(GSXML.NODE_TYPE_ATT, GSXML.NODE_TYPE_LEAF);
 	    } else {
-		node.setAttribute(GSXML.NODE_TYPE_ATT, GSXML.NODE_TYPE_INTERIOR);
+		node.setAttribute(GSXML.NODE_TYPE_ATT, GSXML.NODE_TYPE_INTERNAL);
 	    }
 	} 
@@ -794,5 +794,5 @@
 		}
 		metadata_list.add(metadata);
-	    } else if (param.getAttribute(GSXML.NAME_ATT).equals(EXTLINK_PARAM)&& GSXML.getValue(param).equals("1")) {
+	    } else if (param.getAttribute(GSXML.NAME_ATT).equals(EXTID_PARAM)&& GSXML.getValue(param).equals("1")) {
 		extlink = true;
 	    }
@@ -824,7 +824,7 @@
 		    // just ignore the extension cos it has no meaning here
 		    // or should it be added back on for the next step???
-		    node_id = this.gdbm_src.extlink2OID(node_id.substring(0,node_id.length()-3));
+		    node_id = this.gdbm_src.externalId2OID(node_id.substring(0,node_id.length()-3));
 		} else {
-		    node_id = this.gdbm_src.extlink2OID(node_id);
+		    node_id = this.gdbm_src.externalId2OID(node_id);
 		}
 	    }
@@ -850,5 +850,5 @@
 		    String key = (String)it.next();
 		    String value = info.getInfo(key);
-		    GSXML.addMetadata(this.doc, node_meta_list, key, this.macro_resolver.resolve(value, lang, GS2MacroResolver.SCOPE_META, node_id, info));
+		    GSXML.addMetadata(this.doc, node_meta_list, key, this.macro_resolver.resolve(value, lang, GS2MacroResolver.SCOPE_META, node_id));
 		}
 	    } else { // just get the selected ones
@@ -875,5 +875,5 @@
 	if (pos ==-1) {
 	    // just a plain meta entry eg dc.Title
-	    return macro_resolver.resolve((String)info.getInfo(metadata), lang, GS2MacroResolver.SCOPE_META, node_id, info);
+	    return macro_resolver.resolve((String)info.getInfo(metadata), lang, GS2MacroResolver.SCOPE_META, node_id);
 	}
 	
@@ -935,5 +935,5 @@
 
 	if (!multiple) {
-	    result.append(this.macro_resolver.resolve(relation_info.getInfo(metadata), lang, GS2MacroResolver.SCOPE_META, relation_id, relation_info));
+	    result.append(this.macro_resolver.resolve(relation_info.getInfo(metadata), lang, GS2MacroResolver.SCOPE_META, relation_id));
 	} else {
 	    // we have multiple meta
@@ -947,5 +947,5 @@
 			result.append(separator);
 		    }
-		    result.append(this.macro_resolver.resolve((String)values.elementAt(i), lang, GS2MacroResolver.SCOPE_META, relation_id, relation_info));
+		    result.append(this.macro_resolver.resolve((String)values.elementAt(i), lang, GS2MacroResolver.SCOPE_META, relation_id));
 		}
 	    }
@@ -964,5 +964,5 @@
 	    if (!multiple) {
 		result.insert(0, separator);
-		result.insert(0, this.macro_resolver.resolve(relation_info.getInfo(metadata), lang, GS2MacroResolver.SCOPE_META, relation_id, relation_info));
+		result.insert(0, this.macro_resolver.resolve(relation_info.getInfo(metadata), lang, GS2MacroResolver.SCOPE_META, relation_id));
 	    } else {
 		Vector values = relation_info.getMultiInfo(metadata);
@@ -970,5 +970,5 @@
 		    for (int i=values.size()-1; i>=0; i--) {
 			result.insert(0, separator);
-			result.insert(0, this.macro_resolver.resolve((String)values.elementAt(i), lang, GS2MacroResolver.SCOPE_META, relation_id, relation_info));
+			result.insert(0, this.macro_resolver.resolve((String)values.elementAt(i), lang, GS2MacroResolver.SCOPE_META, relation_id));
 		    }
 		}
@@ -1005,5 +1005,5 @@
 	}
 	// resolve any collection specific macros
-	doc_content = macro_resolver.resolve(doc_content, lang, GS2MacroResolver.SCOPE_TEXT, doc_id, info);
+	doc_content = macro_resolver.resolve(doc_content, lang, GS2MacroResolver.SCOPE_TEXT, doc_id);
 	return doc_content;
     }
Index: /trunk/gsdl3/src/java/org/greenstone/gsdl3/service/GS3Browse.java
===================================================================
--- /trunk/gsdl3/src/java/org/greenstone/gsdl3/service/GS3Browse.java	(revision 8959)
+++ /trunk/gsdl3/src/java/org/greenstone/gsdl3/service/GS3Browse.java	(revision 8959)
@@ -0,0 +1,186 @@
+/*
+ *    GS3Browse.java
+ *    Copyright (C) 2005 New Zealand Digital Library, http://www.nzdl.org
+ *
+ *    This program is free software; you can redistribute it and/or modify
+ *    it under the terms of the GNU General Public License as published by
+ *    the Free Software Foundation; either version 2 of the License, or
+ *    (at your option) any later version.
+ *
+ *    This program is distributed in the hope that it will be useful,
+ *    but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *    GNU General Public License for more details.
+ *
+ *    You should have received a copy of the GNU General Public License
+ *    along with this program; if not, write to the Free Software
+ *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ */
+package org.greenstone.gsdl3.service;
+
+// Greenstone classes
+import org.greenstone.gsdl3.util.GS3OID;
+import org.greenstone.gsdl3.util.GSXML;
+import org.greenstone.gsdl3.util.GSFile;
+import org.greenstone.gsdl3.util.SQLQuery;
+
+// XML classes
+import org.w3c.dom.Document;
+import org.w3c.dom.Element; 
+import org.w3c.dom.NodeList;
+
+// General Java classes
+import java.util.ArrayList;
+import java.util.StringTokenizer;
+import java.io.File;
+
+/** Greenstone 3 collection classifier service
+ *
+ * @author <a href="mailto:kjdon@cs.waikato.ac.nz">Katherine Don</a>
+ */
+public class GS3Browse
+    extends AbstractBrowse
+{
+
+    protected SQLQuery database = null;
+
+    /** constructor */
+    public GS3Browse()
+    {
+	this.database = new SQLQuery();
+
+    }
+
+    public boolean configure(Element info, Element extra_info)
+    {
+	System.err.println("Configuring GS3Browse...");
+	
+	// open the database for querying
+	// the database name is a combination of site name and collection name
+
+	// check that site_home is set
+	if (this.site_home == null || this.site_home.equals("")) {
+	    System.err.println("GS3Retrieve Error: site_home is not set, so cannot work out the site name and cannot determine the database name");
+	    return false;
+	}
+	String site_name = this.site_home.substring(this.site_home.lastIndexOf(File.separator)+1);
+	if (site_name.equals("")) {
+	    System.err.println("GS3Retrieve Error: Cannot extract the site name from site home: "+this.site_home);
+	    return false;
+	}
+	if (!database.setDatabase(site_name+"_"+this.cluster_name)) {
+	    System.err.println("GS3Retrieve Error: Could not open SQL database!");
+	    return false;
+	}
+	
+	// generic configure
+	return super.configure(info, extra_info);
+    }
+
+    /** if id ends in .fc, .pc etc, then translate it to the correct id */
+    protected String translateId(String node_id) {
+	// should really use a sql query
+	return GS3OID.translateOID(node_id);
+    }
+
+        /** returns the document type of the doc that the specified node 
+	belongs to. should be one of 
+	GSXML.DOC_TYPE_SIMPLE, 
+	GSXML.DOC_TYPE_PAGED, 
+	GSXML.DOC_TYPE_HIERARCHY
+    */
+    protected String getDocType(String node_id) {
+	boolean hierarchical = false;
+	if (!GS3OID.isDocTop(node_id) || database.isHierarchicalDocument(node_id) ) {
+	    hierarchical = true;
+	} 
+	// what about paged???
+	if (!hierarchical) {
+	    // a simple document
+	    return GSXML.DOC_TYPE_SIMPLE;
+	} else {
+	    // a hierarchical doc
+	    return GSXML.DOC_TYPE_HIERARCHY;
+	}
+	// don't have paged yet.
+   }
+    
+    /** returns the id of the root node of the document containing node 
+     * node_id. . may be the same as node_id */
+    protected String getRootId(String node_id) {
+	return GS3OID.getDocID(node_id);
+    }
+    
+   /** returns a list of the child ids in order, null if no children */
+    protected ArrayList getChildrenIds(String node_id) {
+	ArrayList documents = database.getClassifierDocChildren(node_id);
+	if (documents == null) {
+	    documents = new ArrayList();
+	}
+	ArrayList children = database.getClassifierChildren(node_id);
+	if (children != null) {
+	    documents.addAll(children);
+	}
+	if (documents.size()==0) {
+	    return null;
+	}
+	return documents;
+    }
+
+    /** returns the node id of the parent node, null if no parent */
+    protected String getParentId(String node_id){
+	String parent = GS3OID.getParent(node_id);
+	if (parent.equals(node_id)) {
+	    return null;
+	}
+	return parent;
+    }
+    
+    /** get the metadata for the classifier node node_id
+     * returns a metadataList element:
+     * <metadataList><metadata name="xxx">value</metadata></metadataList>
+     * if all_metadata is true, returns all available metadata, otherwise just
+     * returns requested metadata
+     */
+    // assumes only one value per metadata
+    protected Element getMetadataList(String node_id, boolean all_metadata, ArrayList metadata_names) {
+	Element metadata_list = this.doc.createElement(GSXML.METADATA_ELEM+GSXML.LIST_MODIFIER);
+
+	if (all_metadata) {
+	    // TODO
+	    
+
+	} else {
+	    for (int m = 0; m < metadata_names.size(); m++) {
+		String metadata = (String) metadata_names.get(m);
+		String value = null;
+		value = database.getClassifierMetadata(node_id, metadata);
+		if (value != null) {
+		    System.out.println("found value "+value);
+		    GSXML.addMetadata(this.doc, metadata_list, metadata, value);
+		}
+	    }
+	}
+
+	return metadata_list;
+    }
+
+    /** returns the structural information asked for.
+     * info_type may be one of
+     * INFO_NUM_SIBS, INFO_NUM_CHILDREN, INFO_SIB_POS
+     */
+    protected String getStructureInfo(String doc_id, String info_type) {
+	return null;
+    }
+
+    /** returns true if the id refers to a document (rather than 
+     * a classifier node)
+     */
+    protected boolean isDocumentId(String node_id){
+	if (node_id.startsWith("CL")) {
+	    return false;
+	}
+	return true;
+    }
+
+}
Index: /trunk/gsdl3/src/java/org/greenstone/gsdl3/service/GS3MGPPRetrieve.java
===================================================================
--- /trunk/gsdl3/src/java/org/greenstone/gsdl3/service/GS3MGPPRetrieve.java	(revision 8959)
+++ /trunk/gsdl3/src/java/org/greenstone/gsdl3/service/GS3MGPPRetrieve.java	(revision 8959)
@@ -0,0 +1,112 @@
+/*
+ *    GS3MGPPRetrieve.java
+ *    Copyright (C) 2005 New Zealand Digital Library, http://www.nzdl.org
+ *
+ *    This program is free software; you can redistribute it and/or modify
+ *    it under the terms of the GNU General Public License as published by
+ *    the Free Software Foundation; either version 2 of the License, or
+ *    (at your option) any later version.
+ *
+ *    This program is distributed in the hope that it will be useful,
+ *    but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *    GNU General Public License for more details.
+ *
+ *    You should have received a copy of the GNU General Public License
+ *    along with this program; if not, write to the Free Software
+ *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ */
+package org.greenstone.gsdl3.service;
+
+// Greenstone classes
+import org.greenstone.mgpp.*;
+import org.greenstone.gsdl3.util.GSFile;
+import org.greenstone.gsdl3.util.GSXML;
+import org.greenstone.gsdl3.util.GS3OID;
+
+// XML classes
+import org.w3c.dom.Element;
+import org.w3c.dom.Text;
+
+// General Java classes
+import java.io.File;
+
+public class GS3MGPPRetrieve
+    extends AbstractGS3DocumentRetrieve
+{
+    // Elements used in the config file that are specific to this class
+    private static final String DEFAULT_LEVEL_ELEM = "defaultLevel";
+
+    private MGPPWrapper mgpp_src = null;
+    
+    private String default_level = null;
+    private String mgpp_textdir = null;
+	
+    public GS3MGPPRetrieve() {
+	this.mgpp_src = new MGPPWrapper();
+    }
+
+    /** configure this service */
+    public boolean configure(Element info, Element extra_info)
+    {
+	// Do specific configuration
+	System.out.println("Configuring GS3MGPPRetrieve...");
+
+	// Get the default level out of <defaultLevel> (buildConfig.xml)
+	Element def = (Element) GSXML.getChildByTagName(info, DEFAULT_LEVEL_ELEM);
+	if (def != null) {
+	    this.default_level = def.getAttribute(GSXML.NAME_ATT);
+	}
+	if (this.default_level == null || this.default_level.equals("")) {
+	    System.err.println("Error: default level not specified!");
+	    return false;
+	}
+	// System.out.println("Default level: " + default_level_);
+	
+	// The location of the MGPP text files
+	mgpp_textdir = GSFile.collectionBaseDir(this.site_home, this.cluster_name) +
+	    File.separatorChar + GSFile.collectionTextPath(this.cluster_name);
+
+	// Do generic configuration
+	return super.configure(info, extra_info);
+ 
+    }
+    
+    /** returns the content of a node
+     * should return a nodeContent element:
+     * <nodeContent>text content or other elements</nodeContent>
+     */
+    protected Element getNodeContent(String doc_id) {
+	if (GS3OID.isDocTop(doc_id) && database.isHierarchicalDocument(doc_id)) {
+	    // if we have a whole doc id, and the document is hierarchical,
+	    // we want to change the id to be the top id of the section 
+	    // hierarchy
+	    doc_id = GS3OID.createOID(doc_id, "1");
+	}
+
+	String doc_num = this.database.OID2MGNum(doc_id);	    
+	// doc nums have the index prefixed 
+	doc_num = doc_num.substring(doc_num.indexOf(".")+1);
+	int doc_int = Integer.parseInt(doc_num);
+
+	Element content_node = this.doc.createElement(GSXML.NODE_CONTENT_ELEM);
+	
+	String doc_content = "";
+	try {
+	    doc_content = this.mgpp_src.getDocument(this.mgpp_textdir, 
+						    this.default_level,
+						    doc_int);
+	    doc_content = resolveRelativeLinks(doc_content, doc_id);
+	} catch (Exception e) {
+	    System.out.println("exception happended with mgpp_src.getDocument()" + e);
+	    doc_content = "this is the content for section hash id "+ doc_id+", mgpp doc num "+doc_int+"\n";
+	}
+
+	Text t = this.doc.createTextNode(doc_content);
+	content_node.appendChild(t);
+	return content_node;
+
+    }
+
+
+}
